#!/bin/sh

#============================================
#==     Observation log tool               ==
#==     for the IOTA 3T interferometer     ==
#==                                        ==
#==     (c) 2005 Stefan Kraus              ==
#==     mail: skraus@mpifr-bonn.mpg.de     ==
#============================================

if test $# -lt 1;then
  echo "Usage: createobslog.sh [DataPath]"
  echo
  exit 1
fi

DATAPATH=$1

more $DATAPATH/iota*.header | grep "Filename :" | cut -d':' -f 2 > createobslog.tmp1
more $DATAPATH/iota*.header | grep "Star :" | cut -d':' -f 2 > createobslog.tmp2
more $DATAPATH/iota*.header | grep "UT Date :" | cut -d':' -f 2 | cut -b1-15 > createobslog.tmp4
more $DATAPATH/iota*.header | grep "UT Time :" | cut -d':' -f 2 | cut -b1-12 > createobslog.tmp5
more $DATAPATH/iota*.header | grep "Shutters :" | cut -d':' -f 2 > createobslog.tmp6

rm -f createobslog.tmp3
for FILE in `cat createobslog.tmp1`
do
  FILE2=`basename $FILE | cut -b5-100 | cut -d'.' -f1`
  echo "$FILE2  " >> createobslog.tmp3

  FILE3=`basename $FILE`
  echo "$FILE3  " >> createobslog.tmp1b
done

paste createobslog.tmp3 createobslog.tmp1b createobslog.tmp2 createobslog.tmp4 createobslog.tmp5 createobslog.tmp6 | awk '{printf "%-4s %-20s %-15s  %-4s-%-2s-%-2s %-2s:%-2s:%-2s %-10s %-10s %-10s\n", $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12;}' > createobslog.tmpf
sort -n -k 1 createobslog.tmpf > $DATAPATH/obslog

rm -f createobslog.tmp1
rm -f createobslog.tmp1b
rm -f createobslog.tmp2
rm -f createobslog.tmp3
rm -f createobslog.tmp4
rm -f createobslog.tmp5
rm -f createobslog.tmp6
rm -f createobslog.tmpf
