
union _M2 
{
  char cd[2];
  unsigned short i2d;
};

union _M4
{
  char cd[4];
  float r4d;
  unsigned long i4d;
  unsigned short i2d[2];
};

union _M8
{
  char cd[8];
  double r8d;
  float r4d[2];
  unsigned long i4d[2];
  unsigned short i2d[4];
};

typedef union _M2 M2Byte;
typedef union _M4 M4Byte;
typedef union _M8 M8Byte;

void swap2(M2Byte*);
void swap4(M4Byte*);
void swap8(M8Byte*);

void swap2(M2Byte *A)
{
  M2Byte temp;
  
  temp.cd[0] = A->cd[1];
  temp.cd[1] = A->cd[0];
  
  A->cd[0] = temp.cd[0];
  A->cd[1] = temp.cd[1];
}

void swap4(M4Byte *A)
{
  M4Byte temp;
  
  temp.cd[0] = A->cd[3];
  temp.cd[1] = A->cd[2];
  temp.cd[2] = A->cd[1];
  temp.cd[3] = A->cd[0];
  
  A->cd[0] = temp.cd[0];
  A->cd[1] = temp.cd[1];
  A->cd[2] = temp.cd[2];
  A->cd[3] = temp.cd[3];
}

void swap8(M8Byte *A)
{
  M4Byte temp0, temp1;
  
  temp0.i4d = A->i4d[1];
  temp1.i4d = A->i4d[0];
  
  swap4(&temp0);
  swap4(&temp1);
  
  A->i4d[0] = temp0.i4d;
  A->i4d[1] = temp1.i4d;
}
