/* histo.c                                   */
/* Interferometry Data Reduction Software    */
/* by Stefan Kraus                           */
/* 2002-05                                   */
/*                                           */
/* copyright laws apply                      */

#define max_bins 500
#define max_data 500

void histogram(char *filename, int nrbins)
{
     float data[max_data];
     int bins[max_bins];
     double datamin, datamax;
     double mean, rootvar, x, sum;
     long nrdata;
     fftw_plan p;
     int i, j;
     float datax[max_bins], datay[max_bins];
     float ymin, ymax, xmin, xmax, binwidth;
     FILE *stream;

     stream = fopen(filename, "r");

     i = 0;
     datamin = 1e308;
     datamax = -1e308;
     while (feof(stream) == 0)
     {
	 i++;
	 fscanf(stream, "%f\n", &data[i]);
	 if (data[i] > datamax) datamax = data[i];
	 if (data[i] < datamin) datamin = data[i];
     }
     nrdata = i-1;

     fclose(stream);


     binwidth = datamax/(nrbins-5);


     //put the data into bins
     for (i=0; i<=max_bins; i++)
	 bins[i] = 0;

     for (i=0; i<=nrdata; i++)
     {
	 j = (int)(data[i]/binwidth);
	 bins[j]++;
     }


     //plot histogram
     ymin = 1.0e10;
     ymax = -1.0e10;
     //xmin = 1.0e10;
     //xmax = -1.0e10;
     
     for (i=0; i<nrbins; i++)
     {
	 datax[i] = i*binwidth;
	 datay[i] = bins[i];
	 
	 //if ((datay[i] > 0.0) && (i > xmax)) xmax = i;
	 //if ((datay[i] > 0.0) && (i < xmin)) xmin = i;
	 if (datay[i] < ymin) ymin = datay[i];
	 if (datay[i] > ymax) ymax = datay[i];
     }
     
     cpgsci(1);
     cpgenv(0, nrbins*binwidth, 0, ymax*1.1, 0, 1);
     
     cpgline(nrbins, datax, datay);
}
