/* powspec.c                                 */
/* Interferometry Data Reduction Software    */
/* by Stefan Kraus                           */
/* 2002-05                                   */
/*                                           */
/* copyright laws apply                      */

fftw_plan fftw_powspec;

// calculates the power spectrum

int calc_powspec(double *data, double *power)
{
  int nn[3], i;
  double powspec[2*nPtsScan], data2[nPtsScan], powspeca[nPtsScan], powspecb[nPtsScan];
  fftw_complex in[nPtsScan], out[nPtsScan];

  double sum;

  nn[0] = nPtsScan;
  nn[1] = 2;
  nn[2] = 0;


  //*** Windowing
  for (i=0; i<nPtsScan; i++)
  {
      in[i].re = data[i];// * (1-pow((i - 0.5*nPtsScan)/(0.5*nPtsScan), 2));
      in[i].im = 0.0;
  }
  //data2[i] = data[i] * (1-pow((i - 0.5*nPtsScan)/(0.5*nPtsScan), 2));
  

  fftw_powspec = fftw_create_plan(nPtsScan, FFTW_FORWARD, FFTW_ESTIMATE);
  fftw_one(fftw_powspec, in, out);
  fftw_destroy_plan(fftw_powspec);
  
  for (i=0; i<nPtsScan/2; i++)
      //power[i] = sqr(sqrt(sqr(out[i].im)+sqr(out[i].re)))/(double)nPtsScan;
      power[i] = (sqr(out[i].re)+sqr(out[i].im))/(double)nPtsScan;
}
