#!/bin/sh

#============================================
#==     Realtime data reduction script     ==
#==     for the IOTA 3T interferometer     ==
#==                                        ==
#==     (c) 2004 Stefan Kraus              ==
#==     mail: skraus@mpifr-bonn.mpg.de     ==
#============================================

test "$2" = "" && { echo "Usage: sh idrsobs [Command] [DataDir]"; echo "     [Command]=start"; echo "  or [Command]=number of file to process"; exit; }

set +xv   # xtrace und verbose aktivieren: -xv

path=$2 
#"/home/skraus/shtest/data/"

INIfile=$"obs.ini"

file1=$"iota"
file2=$".header"
nrstart=1
declare -i nr=1
declare -i nrplus=1
declare -i nrmax=100
declare -i exist

#*** For a new run, clean up first
test "$1" = "start" && { rm obs.ini; rm amp.dat; rm bispec.dat; rm amp.dat; }
test "$1" != "start" && { nrstart=$1; }

./idrsplot -silent -wait 10 &
IDRSPLOT=$(ps -e | grep idrsplot)

for ((nr=$nrstart; nr<10000; nr++)); do
	eval "filename"=\'"$path$file1$nr$file2"\'
	nrplus=$(($nr+1))
	eval "filenameplus"=\'"$path$file1$nrplus$file2"\'
	
	#*** generate INI file
	eval "INIcommand1"=\'"DataRootDir: $path"\'
	(echo $INIcommand1) > obs.ini
	eval "INIcommand2"=\'"Dir: $path  Files: 0 to 0  Scan: 0 to 0"\'
	(echo $INIcommand2) >> obs.ini
	
	#*** for each file start ./idrs obs
	echo "Press ENTER to exit"
	while :; do
		test -e "$filenameplus" && { echo "Done."; break; }
		read -p "." -t 1 && { ./idrs obs $nr -f $INIfile ; kill -9 $IDRSPLOT; exit; }
	done

	echo
	echo - - - PROCESSING: File $nr
	
	./idrs obs $nr -f $INIfile
done

kill -9 $IDRSPLOT
